#include <sys/stat.h>

#include "host_file_accessor.h"
#include "host_file_opener.h"

/* Return a file identifier for the given 'path'. */

fileid_t HostFileOpener::get_fileid(const char *path)
{
    struct stat statbuf;

    /* Obtain the inode number.
       NOTE: This does not handle errors! */

    stat(path, &statbuf);

    _paths.insert(FilePathEntry(statbuf.st_ino, path));

    return statbuf.st_ino;
}

/* Return a new accessor for 'fileid'. */

Accessor *HostFileOpener::make_accessor(fileid_t fileid)
{
    FilePaths::iterator found = _paths.find(fileid);

    if (found != _paths.end())
        return new HostFileAccessor(found->second, fileid);
    else
        return NULL;
}

// vim: tabstop=4 expandtab shiftwidth=4
